/*MA****************************************************************/
/*                                                                 */
/*  FILE     draw-buffer.c                                         */
/*  MODULE   draw-buffer                                           */
/*  PROGRAM  vpf                                                   */
/*  AUTHOR   Helmut Schmid, IMS, University of Stuttgart           */
/*  PURPOSE  string buffer routines                                */
/*                                                                 */
/*ME****************************************************************/

#include <string.h>
#include <malloc.h>
#include <stdarg.h>

#include "draw-buffer.h"

static long Buffer_Size=0;
static long Buffer_Pointer=0;
static char *Buffer=NULL;


/*FA****************************************************************/
/*                                                                 */
/*  resize_buffer                                                  */
/*                                                                 */
/*FE****************************************************************/

static void resize_buffer()

{
  if (Buffer_Size == 0)
    Buffer_Size = 1000;
  else
    Buffer_Size *= 2;
  Buffer = (char*) realloc (Buffer, sizeof(char) * Buffer_Size);
}


/*FA****************************************************************/
/*                                                                 */
/*  append_to_buffer                                               */
/*                                                                 */
/*FE****************************************************************/

void append_to_buffer( char *string )

{
  int l = strlen(string);

  while (Buffer_Pointer + l >= Buffer_Size)
    resize_buffer();
  strcpy( Buffer+Buffer_Pointer, string );
  Buffer_Pointer += l;
}


/*FA****************************************************************/
/*                                                                 */
/*  get_buffer                                                     */
/*                                                                 */
/*FE****************************************************************/

char *get_buffer()

{
  if (Buffer == 0)
    return "";
  Buffer[Buffer_Pointer] = '\0';
  return &Buffer[0];
}


/*FA****************************************************************/
/*                                                                 */
/*  clear_buffer                                                   */
/*                                                                 */
/*FE****************************************************************/

void clear_buffer( )

{
  Buffer_Size = Buffer_Pointer = 0;
  free(Buffer);
  Buffer = NULL;
}
