%option 8Bit batch yylineno noyywrap
%{
/*MA****************************************************************/
/*                                                                 */
/*  FILE     scanner.l                                             */
/*  MODULE   scanner                                               */
/*  PROGRAM  vpf                                                   */
/*  AUTHOR   Helmut Schmid, IMS, University of Stuttgart           */
/*                                                                 */
/*ME****************************************************************/

#include <string.h>

#include "basic-functions.h"
#include "parse-forest.h"
#include "y.tab.h"

%}


%%

#i                { return IFLAG; }

#h                { return HFLAG; }

#[0-9][0-9]*=     {
		    sscanf(yytext+1, "%d", &yylval.number);
		    return DFLAG;
		  }

#[0-9][0-9]*      {
		    sscanf(yytext+1, "%d", &yylval.number);
		    return RFLAG;
		  }

\"([^\n\"\\]|(\\.))*\" { 
                    yylval.string = strdup(unquote(yytext));
		    return STRING;
                  }

\'([^\n\'\\]|(\\.))*\' { 
                    yylval.string = strdup(unquote(yytext));
		    return STRING;
                  }

([/A-Za-z0-9_#@-!`~|&%?,;:.*+-]|(\\.))+ {
                    yylval.string = strdup(unquote(yytext));
		    return STRING;
	          }

[][(){}=<>^$]     { return yytext[0]; }

[ \n\t]           { /* ignored */ }

.                 { error2("unexpected", yytext); }

%%
