/*MA****************************************************************/
/*                                                                 */
/*  FILE     tcl-interface.h                                       */
/*  MODULE   tcl-interface                                         */
/*  PROGRAM  vpf                                                   */
/*  AUTHOR   Helmut Schmid, IMS, University of Stuttgart           */
/*                                                                 */
/*ME****************************************************************/


int Vpf_Init( Tcl_Interp *interp );

/* list of Tcl commands defined by this module:
 *
 * drawCommands: returns the draw commands as a string
 * Out: String
 * In: Number of parse forest to be drawn
 *
 * highlight: marks a node as highlighted
 * In: x and y position of mouse
 *
 * explode
 * In: x and y position of mouse
 *
 * implode",
 * In: x and y position of mouse
 *
 * parseForestCount
 * Out: number of parse forests read


 * The following draw commands are used and
 * have to be implemented by a Tcl script:
 * 
 * d x y         : set the size of the scroll region to (x,y)
 * e x1 y1 x2 y2 : draw a line from (x1,y1) to (x2,y2)
 * h x1 y1 x2 y2 : highlight the rectangle from (x1,y1) to (x2,y2)
 * l x y {string}: draw "string" at position (x,y) anchored nw
 * t x y n       : draw the tag with number n at position (x,y)
 * i x y n       : draw an implosion mark at position (x,y)
 * lcb x y l     : draw a left curly bracket of length l anchored nw at 
 *                 position (x,y)
 * lsb x y l     : draw a left square bracket ...
 * lcb x y l     : draw a right curly bracket anchored ne at ...
 * lcb x y l     : draw a right square bracket ...
 */
